#include "TlinkPool.h"


TlinkPool::TlinkPool() 
{
	resetAllLinks();
	fAllocatedPools = 0;
	for (int i=0; i<NUM_LINK_POOLS; i++)
		fLinkPool[i] = NULL;
}

void TlinkPool::resetAllLinks()
{
	fCurrentPoolIndex = -1;
	fCurrentLinkInPoolIndex = NUM_LINKS_IN_POOL;
}


TlinkType*	TlinkPool::nextFreeLink()
{
	fCurrentLinkInPoolIndex++;

	if (fCurrentLinkInPoolIndex >= NUM_LINKS_IN_POOL) {

		fCurrentLinkInPoolIndex = 0;
		fCurrentPoolIndex++;
		if (fCurrentPoolIndex >= fAllocatedPools) {
			//
			// need to allocate new ones ...
			fLinkPool[fAllocatedPools] = new TlinkType[NUM_LINKS_IN_POOL];
			fAllocatedPools++;
		}
	}
	return &(fLinkPool[fCurrentPoolIndex][fCurrentLinkInPoolIndex]);
}
