#include <stdio.h>
#include "TmyList.h"

void
TmyList::sortedListCheck()
	//
	// go through the list to make sure list is sorted
	// prints out error message if list is not sorted
	// in accending order.
	//
{
	if (fListLength <= 1) 
		return;

	initListForTraversal();

	int key = fCurrentPointer->keyField();
	advanceList();

	while ( notEndOfList() ) {
		int newKey = fCurrentPointer->keyField();
		if ( key > newKey ) {
			fprintf(stderr, "**ERROR**: Keys not in sorted order: [%d %d]\n",
							key, newKey);
		}
		key = newKey;
		advanceList();
	}
}


void
TmyList::duplicateList(TmyList &sourceList)
{
	resetList();
	sourceList.initListForTraversal();
	while ( sourceList.notEndOfList() ) {
		insertElement( sourceList.fCurrentPointer->keyField() );
		sourceList.advanceList();
	}
}

void
TmyList::printListContent(const char *str, bool shouldPrint)
{
	if (!shouldPrint)
		return;

	fprintf(stderr, "Printing List: [%s]\n", str);
	initListForTraversal();
	while ( notEndOfList() ) {
		fprintf(stderr, "	%d\n", fCurrentPointer->keyField() );
		advanceList();
	}
}
