#include "TmyList.h"

void 
TmyList::insertionSort()
{
	fprintf(stderr, "Insertion Sort ... one moment ...");

	TlinkType *newList = removeFirstEntry();
	TlinkType *newEntry, *cntPtr, *prePtr;

	while ( (newEntry = removeFirstEntry()) != NULL ) {
		if (newEntry->keyField() <= newList->keyField()) {
			// insert at the beginning
			newEntry->nextField() = newList;
			newList = newEntry;
		} else {
			cntPtr = newList;
			prePtr = cntPtr;
			while ( (cntPtr != NULL) && 
			    	(newEntry->keyField() > cntPtr->keyField()) ) {
				prePtr = cntPtr;
				cntPtr = cntPtr->nextField();
			}
			newEntry->nextField() = cntPtr;
			prePtr->nextField() = newEntry;
		}
	}
	fHeadPointer = newList;
	fprintf(stderr, "\n!!done!!\n");
}


void 
TmyList::mergeSortCombine(
		TlinkType *&resultList,
		TlinkType  *firstList,
		TlinkType  *secondList
)
{
	TlinkType *resultPtr;

	if (firstList->keyField() < secondList->keyField() ) {
		resultList = firstList;
		firstList = firstList->nextField();
	} else {
		resultList = secondList;
		secondList = secondList->nextField();
	}
	resultList->nextField() = NULL;

	resultPtr = resultList;

	while ( (firstList!=NULL) && (secondList!=NULL) ) {
			
		if (firstList->keyField() < secondList->keyField() ) {
			resultPtr->nextField() = firstList;
			resultPtr = firstList;
			firstList = firstList->nextField();
		} else {
			resultPtr->nextField() = secondList;
			resultPtr = secondList;
			secondList = secondList->nextField();
		}
		resultPtr->nextField() = NULL;
	}

	if ( firstList!=NULL )
		resultPtr->nextField() = firstList;
	else
		resultPtr->nextField() = secondList;
			
}

TlinkType*
TmyList::breakListToTwoAt(
	TlinkType *list,
	int			pos
)
{
	TlinkType *newList = list->nextField();
	TlinkType *prePtr = list;

	for (int i=0; i<pos-1; i++) {
		newList = newList->nextField();
		prePtr = prePtr->nextField();
	}
	prePtr->nextField() = NULL;
	return newList;
}
	
void
TmyList::mergeSortDivide(
		TlinkType *&list,
		int		   length
)
{
	if (length > 1) {
		int newLength = length / 2;
		TlinkType *newList2 = breakListToTwoAt(list, newLength);
		TlinkType *newList1 = list;
		mergeSortDivide(newList1, newLength);
		mergeSortDivide(newList2, length-newLength);
		mergeSortCombine(list, newList1, newList2);
	}
}

void 
TmyList::mergeSort()
{
	fprintf(stderr, "Merge Sort ... one moment ...");
	mergeSortDivide(fHeadPointer, fListLength);
	fprintf(stderr, "\n!!done!!\n");
}
